
project device/nxp/
diff --git a/imx8m/BoardConfigCommon.mk b/imx8m/BoardConfigCommon.mk
index 9b5b8ddb..e20d6c18 100644
--- a/imx8m/BoardConfigCommon.mk
+++ b/imx8m/BoardConfigCommon.mk
@@ -14,7 +14,10 @@ PRODUCT_MANUFACTURER \
 BOARD_VPU_ONLY \
 BOARD_HAVE_VPU \
 PREBUILT_FSL_IMX_CODEC \
-POWERSAVE
+POWERSAVE	\
+SF_PRIMARY_DISPLAY_ORIENTATION
+
+SOONG_CONFIG_IMXPLUGIN_SF_PRIMARY_DISPLAY_ORIENTATION = 270
 
 SOONG_CONFIG_IMXPLUGIN_BOARD_PLATFORM = imx8
 SOONG_CONFIG_IMXPLUGIN_BOARD_USE_SENSOR_FUSION = true
diff --git a/imx8m/evk_8mp/BoardConfig.mk b/imx8m/evk_8mp/BoardConfig.mk
index d9fb24e2..d695bb8c 100644
--- a/imx8m/evk_8mp/BoardConfig.mk
+++ b/imx8m/evk_8mp/BoardConfig.mk
@@ -62,6 +62,8 @@ else
   endif
 endif
 
+
+SF_PRIMARY_DISPLAY_ORIENTATION := 270
 BOARD_PREBUILT_DTBOIMAGE := $(OUT_DIR)/target/product/$(PRODUCT_DEVICE)/dtbo-imx8mp.img
 
 BOARD_USES_METADATA_PARTITION := true
diff --git a/imx8m/evk_8mp/android_addition_defconfig b/imx8m/evk_8mp/android_addition_defconfig
index 49fcf244..a6414d78 100644
--- a/imx8m/evk_8mp/android_addition_defconfig
+++ b/imx8m/evk_8mp/android_addition_defconfig
@@ -1,2 +1,3 @@
 CONFIG_LIBNVDIMM=y
 CONFIG_OF_PMEM=y
+CONFIG_INV_MPU6050_I2C=y
diff --git a/imx8m/evk_8mp/evk_8mp.mk b/imx8m/evk_8mp/evk_8mp.mk
index e32744b2..f2ca8aba 100644
--- a/imx8m/evk_8mp/evk_8mp.mk
+++ b/imx8m/evk_8mp/evk_8mp.mk
@@ -3,6 +3,11 @@ CONFIG_REPO_PATH := device/nxp
 CURRENT_FILE_PATH :=  $(lastword $(MAKEFILE_LIST))
 IMX_DEVICE_PATH := $(strip $(patsubst %/, %, $(dir $(CURRENT_FILE_PATH))))
 
+USE_SENSOR_MULTI_HAL := true
+TARGET_SUPPORT_DIRECT_REPORT := true
+# Enable sensor Version V_2
+USE_SENSOR_HAL_VER := 2.0
+
 # configs shared between uboot, kernel and Android rootfs
 include $(IMX_DEVICE_PATH)/SharedBoardConfig.mk
 
@@ -46,9 +51,38 @@ PRODUCT_PACKAGES += \
     android.hardware.power-service.imx
 
 
-# Thermal HAL
+# Thermal HAL 
 PRODUCT_PACKAGES += \
     android.hardware.thermal@2.0-service.imx
+    
+    
+    
+#LZM SENSROS
+PRODUCT_PRODUCT_PROPERTIES += \
+    persist.vendor.debug.sensors.accel_cal=1
+   
+PRODUCT_COPY_FILES += \
+    frameworks/native/data/etc/android.hardware.sensor.accelerometer.xml:$(TARGET_COPY_OUT_VENDOR)/etc/permissions/android.hardware.sensor.accelerometer.xml \
+    frameworks/native/data/etc/android.hardware.sensor.assist.xml:$(TARGET_COPY_OUT_VENDOR)/etc/permissions/android.hardware.sensor.assist.xml \
+    frameworks/native/data/etc/android.hardware.sensor.compass.xml:$(TARGET_COPY_OUT_VENDOR)/etc/permissions/android.hardware.sensor.compass.xml \
+    frameworks/native/data/etc/android.hardware.sensor.gyroscope.xml:$(TARGET_COPY_OUT_VENDOR)/etc/permissions/android.hardware.sensor.gyroscope.xml \
+    frameworks/native/data/etc/android.hardware.sensor.light.xml:$(TARGET_COPY_OUT_VENDOR)/etc/permissions/android.hardware.sensor.light.xml \
+    frameworks/native/data/etc/android.hardware.sensor.proximity.xml:$(TARGET_COPY_OUT_VENDOR)/etc/permissions/android.hardware.sensor.proximity.xml \
+    frameworks/native/data/etc/android.hardware.sensor.barometer.xml:$(TARGET_COPY_OUT_VENDOR)/etc/permissions/android.hardware.sensor.barometer.xml \
+    frameworks/native/data/etc/android.hardware.sensor.stepcounter.xml:$(TARGET_COPY_OUT_VENDOR)/etc/permissions/android.hardware.sensor.stepcounter.xml \
+    frameworks/native/data/etc/android.hardware.sensor.stepdetector.xml:$(TARGET_COPY_OUT_VENDOR)/etc/permissions/android.hardware.sensor.stepdetector.xml \
+    frameworks/native/data/etc/android.hardware.sensor.hifi_sensors.xml:$(TARGET_COPY_OUT_VENDOR)/etc/permissions/android.hardware.sensor.hifi_sensors.xml
+    
+PRODUCT_PACKAGES += \
+    android.hardware.sensors@2.0-nxp-IIO-Subhal \
+    android.hardware.sensors@2.0-service.multihal \
+    android.hardware.sensors@2.0-service.multihal.rc
+    
+PRODUCT_COPY_FILES += \
+    $(IMX_PATH)/imx/iio_sensor/hals.conf:vendor/etc/sensors/hals.conf \
+    $(IMX_PATH)/imx/iio_sensor/config/sensor_hal_configuration.xml:$(TARGET_COPY_OUT_VENDOR)/etc/sensors/sensor_hal_configuration.xml \
+    $(IMX_PATH)/imx/iio_sensor/config/sensor_hal_configuration.xsd:$(TARGET_COPY_OUT_VENDOR)/etc/sensors/sensor_hal_configuration.xsd
+    
 PRODUCT_COPY_FILES += \
     $(IMX_DEVICE_PATH)/thermal_info_config_imx8mp.json:$(TARGET_COPY_OUT_VENDOR)/etc/configs/thermal_info_config_imx8mp.json
 
diff --git a/imx8m/evk_8mp/init.rc b/imx8m/evk_8mp/init.rc
index 0cd03536..243ea25b 100644
--- a/imx8m/evk_8mp/init.rc
+++ b/imx8m/evk_8mp/init.rc
@@ -270,6 +270,22 @@ on zygote-start && property:vendor.skip.charger_not_need=0
     mkdir /data/vendor/wifi 0771 wifi wifi
     mkdir /data/vendor/wifi/wpa 0770 wifi wifi
     mkdir /data/vendor/wifi/wpa/sockets 0770 wifi wifi
+    #LZM
+    chmod 775 /persist/sensors
+    chmod 664 /persist/sensors/sensors_settings
+    chown root system /persist/sensors/registry
+    chmod 775 /persist/sensors/registry
+    chown root system /persist/sensors/registry/registry
+    chmod 775 /persist/sensors/registry/registry
+
+    chown system root /persist/sensors/sensors_settings
+    chown root root /persist/sensors/registry/registry/sensors_settings
+
+    mkdir /data/vendor/sensors 0770
+    chown system system /data/vendor/sensors
+    mkdir /data/vendor/sensors/log 0770
+    chown system system /data/vendor/sensors/log
+
 
 service early_init_sh /vendor/bin/init.insmod.sh /vendor/etc/early.init.cfg vendor.all.early_init.ready
     class main
diff --git a/imx8m/evk_8mp/required_hardware.xml b/imx8m/evk_8mp/required_hardware.xml
index f751b4ae..494b7640 100644
--- a/imx8m/evk_8mp/required_hardware.xml
+++ b/imx8m/evk_8mp/required_hardware.xml
@@ -26,6 +26,7 @@
     <feature name="android.software.home_screen" />
     <feature name="android.software.input_methods" />
     <feature name="android.hardware.location" />
+    <feature name="android.hardware.sensors" />
     <feature name="android.hardware.location.network" />
     <feature name="android.hardware.bluetooth" />
     <feature name="android.software.companion_device_setup" />

project frameworks/base/
diff --git a/packages/SystemUI/AndroidManifest.xml b/packages/SystemUI/AndroidManifest.xml
index ce1eea0a715c..f0e691da5fd8 100644
--- a/packages/SystemUI/AndroidManifest.xml
+++ b/packages/SystemUI/AndroidManifest.xml
@@ -561,7 +561,7 @@
             android:label="@string/dessert_case"
             android:theme="@android:style/Theme.Black.NoTitleBar.Fullscreen"
             android:launchMode="singleInstance"
-            android:screenOrientation="locked"
+            android:screenOrientation="sensor"
             android:process=":sweetsweetdesserts"
             android:excludeFromRecents="true">
             <intent-filter>
@@ -576,7 +576,7 @@
                   android:icon="@drawable/icon"
                   android:label="@string/mland"
                   android:launchMode="singleInstance"
-                  android:screenOrientation="locked"
+                  android:screenOrientation="sensor"
                   android:process=":sweetsweetdesserts"
                   android:excludeFromRecents="true">
             <intent-filter>
diff --git a/services/core/java/com/android/server/wm/DisplayRotation.java b/services/core/java/com/android/server/wm/DisplayRotation.java
index 1284e009ee3f..2e9a7f20fe1d 100644
--- a/services/core/java/com/android/server/wm/DisplayRotation.java
+++ b/services/core/java/com/android/server/wm/DisplayRotation.java
@@ -1241,6 +1241,7 @@ public class DisplayRotation {
                     return preferredRotation;
                 }
                 return Surface.ROTATION_0;
+                //return Surface.ROTATION_90;
         }
     }
 

project packages/apps/Launcher3/
diff --git a/AndroidManifest.xml b/AndroidManifest.xml
index b031ffbee..f51e4f5b6 100644
--- a/AndroidManifest.xml
+++ b/AndroidManifest.xml
@@ -48,7 +48,7 @@
             android:clearTaskOnLaunch="true"
             android:stateNotNeeded="true"
             android:windowSoftInputMode="adjustPan"
-            android:screenOrientation="unspecified"
+            android:screenOrientation="sensor"
             android:configChanges="keyboard|keyboardHidden|mcc|mnc|navigation|orientation|screenSize|screenLayout|smallestScreenSize"
             android:resizeableActivity="true"
             android:resumeWhilePausing="true"
diff --git a/res/values/config.xml b/res/values/config.xml
index 75fcc907d..ecddc73a1 100644
--- a/res/values/config.xml
+++ b/res/values/config.xml
@@ -1,7 +1,7 @@
 <resources>
     <!-- Miscellaneous -->
     <bool name="config_largeHeap">false</bool>
-    <bool name="allow_rotation">false</bool>
+    <bool name="allow_rotation">true</bool>
 
     <integer name="extracted_color_gradient_alpha">153</integer>
 

project vendor/nxp-opensource/imx/
diff --git a/display/display/Composer.cpp b/display/display/Composer.cpp
index 1122d7b..40232e7 100644
--- a/display/display/Composer.cpp
+++ b/display/display/Composer.cpp
@@ -30,6 +30,12 @@
 #define GPUHELPER "libgpuhelper.so"
 #define G2DENGINE "libg2d"
 
+#ifdef PRIMARY_DISPLAY_ORIENTATION
+static_assert(PRIMARY_DISPLAY_ORIENTATION == 0 || PRIMARY_DISPLAY_ORIENTATION == 90 ||
+                      PRIMARY_DISPLAY_ORIENTATION == 180 || PRIMARY_DISPLAY_ORIENTATION == 270,
+              "Primary display orientation must be 0/90/180/270");
+#endif
+
 namespace fsl {
 
 Composer* Composer::sInstance(0);
@@ -354,6 +360,7 @@ int Composer::clearWormHole(LayerVector& layers)
 
 int Composer::composeLayer(Layer* layer, bool bypass)
 {
+    int transform;
     if (layer == NULL || mTarget == NULL) {
         ALOGE("composeLayer: invalid layer or target");
         return -EINVAL;
@@ -363,6 +370,47 @@ int Composer::composeLayer(Layer* layer, bool bypass)
         ALOGV("composeLayer dim layer bypassed");
         return 0;
     }
+#ifdef PRIMARY_DISPLAY_ORIENTATION
+    int rot = 0;
+
+    switch (layer->transform) {
+        case 0: rot = 0; break;
+        case 4: rot = 1; break; // orgin 90
+        case 3: rot = 2; break; // orgin 180
+        case 7: rot = 3; break; // orgin 270
+    }
+    switch (PRIMARY_DISPLAY_ORIENTATION) {
+        case 0: rot += 0; break;
+        case 90: rot += 1; break;
+        case 180: rot += 2; break;
+        case 270: rot += 3; break;
+    }
+    rot = (rot % 4);
+
+    switch (rot) {
+        case 0: {
+                    transform = 0;
+                    break;
+        }
+        case 1: {
+                    transform = TRANSFORM_ROT90;
+                    break;
+        }
+        case 2: {
+                    transform = TRANSFORM_FLIPH | TRANSFORM_FLIPV;;
+                    break;
+        }
+       case 3: {
+                    transform = TRANSFORM_FLIPH | TRANSFORM_FLIPV | HAL_TRANSFORM_ROT_90;;
+                    break;
+        }
+    }
+
+    ALOGV("transform:0x%x -> 0x%x", layer->transform, transform);
+#else
+    transform = layer->transform;
+#endif
+    
 
     Rect srect = layer->sourceCrop;
     Rect drect = layer->displayFrame;
@@ -397,7 +445,7 @@ int Composer::composeLayer(Layer* layer, bool bypass)
             continue;
         }
 
-        setClipping(srect, drect, clip, layer->transform);
+        setClipping(srect, drect, clip, /*layer->*/transform);
         ALOGV("index:%d, i:%d sourceCrop(l:%d,t:%d,r:%d,b:%d), "
              "visible(l:%d,t:%d,r:%d,b:%d), "
              "display(l:%d,t:%d,r:%d,b:%d)", layer->index, (int)i,
@@ -434,7 +482,7 @@ int Composer::composeLayer(Layer* layer, bool bypass)
             return -EINVAL;
         }
 
-        convertRotation(layer->transform, sSurface, dSurface);
+        convertRotation(/*layer->*/transform, sSurface, dSurface);
         if (!bypass) {
             convertBlending(layer->blendMode, sSurface, dSurface);
         }
diff --git a/display/display/display.go b/display/display/display.go
index ecbd5f4..247e89b 100755
--- a/display/display/display.go
+++ b/display/display/display.go
@@ -54,6 +54,9 @@ func libionallocatorDefaults(ctx android.LoadHookContext) {
     if ctx.Config().VendorConfig("IMXPLUGIN").String("CFG_SECURE_DATA_PATH") == "y" {
         p.Target.Android.Cppflags = append(p.Target.Android.Cppflags, "-DCFG_SECURE_DATA_PATH")
     }
+    if ctx.Config().VendorConfig("IMXPLUGIN").String("SF_PRIMARY_DISPLAY_ORIENTATION") != "" {
+        p.Target.Android.Cppflags = append(p.Target.Android.Cppflags, "-DPRIMARY_DISPLAY_ORIENTATION=" + ctx.Config().VendorConfig("IMXPLUGIN").String("SF_PRIMARY_DISPLAY_ORIENTATION"))
+    }
     if ctx.Config().VendorConfig("IMXPLUGIN").Bool("ENABLE_DMABUF_HEAP") {
         p.Target.Android.Srcs = append(p.Target.Android.Srcs, "DmaHeapAllocator.cpp")
         p.Target.Android.Static_libs = append(p.Target.Android.Static_libs, "libdmabufheap")
diff --git a/iio_sensor/AccMagSensor.cpp b/iio_sensor/AccMagSensor.cpp
index 94ef194..98ae8be 100644
--- a/iio_sensor/AccMagSensor.cpp
+++ b/iio_sensor/AccMagSensor.cpp
@@ -42,12 +42,12 @@ AccMagSensor::AccMagSensor(int32_t sensorHandle, ISensorsEventCallback* callback
         mSensorInfo.power = 0.001f;
         mSensorInfo.maxRange = 39.20f;
         mSensorInfo.resolution = 0.01f;
-        freq_file_name = "/in_accel_sampling_frequency_available";
+        freq_file_name = "/sampling_frequency_available";
     } else if (iio_data.type == SensorType::MAGNETIC_FIELD) {
         mSensorInfo.power = 0.001f;
         mSensorInfo.maxRange = 900.00f;
         mSensorInfo.resolution = 0.01f;
-        freq_file_name = "/in_magn_sampling_frequency_available";
+        freq_file_name = "/sampling_frequency_available";
     }
 
     std::string freq_file;
@@ -91,9 +91,9 @@ void AccMagSensor::batch(int32_t samplingPeriodNs) {
 
         std::string freq_file_name;
         if (mIioData.type == SensorType::ACCELEROMETER) {
-            freq_file_name = "/in_accel_sampling_frequency_available";
+            freq_file_name = "/sampling_frequency_available";
         } else if (mIioData.type == SensorType::MAGNETIC_FIELD) {
-            freq_file_name = "/in_magn_sampling_frequency_available";
+            freq_file_name = "/sampling_frequency_available";
         }
 
         std::string freq_file;
@@ -186,11 +186,19 @@ void AccMagSensor::processScanData(Event* evt) {
     evt->sensorHandle = mSensorInfo.sensorHandle;
     evt->sensorType = mSensorInfo.type;
     if (mSensorInfo.type == SensorType::ACCELEROMETER) {
+        //data process
         get_sensor_acc(mSysfspath, &data);
+        ALOGI("------------>data.x_raw(%d).",  data.x_raw);
+        ALOGI("------------>data.y_raw(%d).",  data.y_raw);
+        ALOGI("------------>data.z_raw(%d).",  data.z_raw);
         // scale sys node is not valid, to meet xTS required range, multiply raw data with 0.005.
-        evt->u.vec3.x  = data.x_raw * 0.005;
-        evt->u.vec3.y  = data.y_raw * 0.005;
-        evt->u.vec3.z  = data.z_raw * 0.005;
+        evt->u.vec3.x  = data.x_raw * 0.0006;
+        evt->u.vec3.y  = data.y_raw * 0.0006;
+        evt->u.vec3.z  = data.z_raw * 0.0006;
+
+        ALOGI("------------>evt->u.vec3.x(%f).",  evt->u.vec3.x);
+        ALOGI("------------>evt->u.vec3.y(%f).",  evt->u.vec3.y);
+        ALOGI("------------>evt->u.vec3.z(%f).",  evt->u.vec3.z);
     } else if(mSensorInfo.type == SensorType::MAGNETIC_FIELD) {
         get_sensor_mag(mSysfspath, &data);
         // 0.000244 is read from sys node in_magn_scale.
diff --git a/iio_sensor/SensorsSubHal.cpp b/iio_sensor/SensorsSubHal.cpp
index 85f0e20..3bb5520 100644
--- a/iio_sensor/SensorsSubHal.cpp
+++ b/iio_sensor/SensorsSubHal.cpp
@@ -54,12 +54,7 @@ static const int gSensorConfigLocationListSize =
 #define MODULE_NAME "android.hardware.sensors@2.0-nxp-IIO-Subhal"
 
 static const std::vector<sensors_supported_hal> sensors_supported = {
-        SENSOR_SUPPORTED("fxas21002c", SensorType::GYROSCOPE),
-        SENSOR_SUPPORTED("isl29023", SensorType::LIGHT),
-        SENSOR_SUPPORTED("mpl3115", SensorType::PRESSURE),
-        SENSOR_SUPPORTED("mpl3115", SensorType::TEMPERATURE),
-        SENSOR_SUPPORTED("fxos8700", SensorType::ACCELEROMETER),
-        SENSOR_SUPPORTED("fxos8700", SensorType::MAGNETIC_FIELD),
+        SENSOR_SUPPORTED("mpu6050", SensorType::ACCELEROMETER),
 };
 
 static std::optional<std::vector<Sensor>> readSensorsConfigFromXml() {
diff --git a/iio_sensor/config/sensor_hal_configuration.xml b/iio_sensor/config/sensor_hal_configuration.xml
index a2c796a..eda514e 100644
--- a/iio_sensor/config/sensor_hal_configuration.xml
+++ b/iio_sensor/config/sensor_hal_configuration.xml
@@ -32,7 +32,7 @@
                         </location>
                     </configuration>
                 </sensor>
-                <sensor name="fxas21002c" type="4">
+                <sensor name="mpu6050" type="4">
                     <configuration>
                         <orientation rotate="true">
                             <x map="0" negate="false"/>
diff --git a/iio_sensor/iio_utils.cpp b/iio_sensor/iio_utils.cpp
index 2d3ef3e..7b5b523 100644
--- a/iio_sensor/iio_utils.cpp
+++ b/iio_sensor/iio_utils.cpp
@@ -49,6 +49,9 @@ static const char* IIO_ACC_Z_RAW = "in_accel_z_raw";
 static const char* IIO_MAG_X_RAW = "in_magn_x_raw";
 static const char* IIO_MAG_Y_RAW = "in_magn_y_raw";
 static const char* IIO_MAG_Z_RAW = "in_magn_z_raw";
+static const char* IIO_GYR_X_RAW = "in_anglvel_x_raw";
+static const char* IIO_GYR_Y_RAW = "in_anglvel_y_raw";
+static const char* IIO_GYR_Z_RAW = "in_anglvel_z_raw";
 static const char* IIO_TRIGGER = "/sys/devices/iio_sysfs_trigger/";
 static const char* IIO_HRTIMER_TRIGGER = "/config/iio/triggers/hrtimer/";
 static const char* IIO_CURRENT_TRIGGER = "/trigger/current_trigger";
@@ -417,6 +420,17 @@ int get_sensor_mag(const std::string& device_dir, struct iio_acc_mac_data* data)
     return 0;
 }
 
+int get_sensor_gyr(const std::string& device_dir, struct iio_acc_mac_data* data) {
+    const std::string x_filename = device_dir + "/" + IIO_GYR_X_RAW;
+    const std::string y_filename = device_dir + "/" + IIO_GYR_Y_RAW;
+    const std::string z_filename = device_dir + "/" + IIO_GYR_Z_RAW;
+    sysfs_read_int(x_filename, &data->x_raw);
+    sysfs_read_int(y_filename, &data->y_raw);
+    sysfs_read_int(z_filename, &data->z_raw);
+    return 0;
+}
+
+
 int64_t get_timestamp(){
     struct timespec ts;
 
diff --git a/iio_sensor/iio_utils.h b/iio_sensor/iio_utils.h
index 7cc1d9e..046042e 100644
--- a/iio_sensor/iio_utils.h
+++ b/iio_sensor/iio_utils.h
@@ -86,6 +86,7 @@ int get_sampling_frequency_available(const std::string& file,
 int get_sensor_light(const std::string& device_dir, unsigned int* light);
 int get_sensor_acc(const std::string& device_dir, struct iio_acc_mac_data* light);
 int get_sensor_mag(const std::string& device_dir, struct iio_acc_mac_data* light);
+int get_sensor_gyr(const std::string& device_dir, struct iio_acc_mac_data* data);
 int add_trigger(const std::string& device_dir,uint8_t dev_num, const bool enable);
 int add_hrtimer_trigger(const std::string& device_dir,uint8_t dev_num, const bool enable);
 int trigger_data(int dev_num);

project vendor/nxp-opensource/kernel_imx/
diff --git a/arch/arm64/boot/dts/freescale/imx8mp-evk.dts b/arch/arm64/boot/dts/freescale/imx8mp-evk.dts
index 81c51d267a6a..23a46eafd501 100755
--- a/arch/arm64/boot/dts/freescale/imx8mp-evk.dts
+++ b/arch/arm64/boot/dts/freescale/imx8mp-evk.dts
@@ -598,7 +598,22 @@ &i2c3 {
 	pinctrl-names = "default";
 	pinctrl-0 = <&pinctrl_i2c3>;
 	status = "okay";
-
+	
+	mpu6050@68 {
+		compatible = "invensense,mpu6050";
+		reg = <0x68>;
+		interrupt-parent = <&gpio5>;
+		interrupts = <27 IRQ_TYPE_EDGE_RISING>;/*uart3_txd gpio*/
+		mount-matrix = "-0.984807753012208",  /* x0 */
+		               "0",                   /* y0 */
+		               "-0.173648177666930",  /* z0 */
+		               "0",                   /* x1 */
+		               "-1",                  /* y1 */
+		               "0",                   /* z1 */
+		               "-0.173648177666930",  /* x2 */
+		               "0",                   /* y2 */
+		               "0.984807753012208";   /* z2 */
+	};
 	pca6416: gpio@20 {
 		compatible = "ti,tca6416";
 		reg = <0x20>;
@@ -829,7 +844,7 @@ &uart2 {
 	pinctrl-0 = <&pinctrl_uart2>;
 	status = "okay";
 };
-
+/*
 &uart3 {
 	pinctrl-names = "default";
 	pinctrl-0 = <&pinctrl_uart3>;
@@ -838,7 +853,7 @@ &uart3 {
 	fsl,uart-has-rtscts;
 	status = "okay";
 };
-
+*/
 &usb3_phy0 {
 	vbus-power-source = <&ptn5110>;
 	fsl,phy-tx-vref-tune = <0xe>;
@@ -1161,7 +1176,7 @@ MX8MP_IOMUXC_UART2_RXD__UART2_DCE_RX	0x49
 			MX8MP_IOMUXC_UART2_TXD__UART2_DCE_TX	0x49
 		>;
 	};
-
+	/*
 	pinctrl_uart3: uart3grp {
 		fsl,pins = <
 			MX8MP_IOMUXC_ECSPI1_SCLK__UART3_DCE_RX		0x140
@@ -1169,7 +1184,7 @@ MX8MP_IOMUXC_ECSPI1_MOSI__UART3_DCE_TX		0x140
 			MX8MP_IOMUXC_ECSPI1_SS0__UART3_DCE_RTS		0x140
 			MX8MP_IOMUXC_ECSPI1_MISO__UART3_DCE_CTS		0x140
 		>;
-	};
+	};*/
 
 	pinctrl_usb1_vbus: usb1grp {
 		fsl,pins = <